/**
 * @function _bud
 */
"use strict";

const pkg = require('../package.json'),
    fs = require('fs'),
    stringcase = require('stringcase');

/** @lends _bud */
function _bud(tmpl, env, model, params) {
    return {
        force: false,
        mode: '644',
        path: `${stringcase.snakecase(env)}/${stringcase.snakecase(model)}.seed.js`,
        mkdirp: true,
        tmpl: tmpl,
        data: {
            params: params,
            generator: 'coz',
            today: new Date().toLocaleDateString(),
            pkg: pkg,
            env: env,
            production: env === 'production',
            model: model
        }
    }
}

_bud.seed = function (env, params) {
    return {
        force: false,
        mode: '644',
        path: `${stringcase.snakecase(env)}/_seed.js`,
        mkdirp: true,
        tmpl: fs.readFileSync(__dirname + '/../asset/_seed.hbs').toString(),
        data: {
            params: params,
            generator: 'coz',
            today: new Date().toLocaleDateString(),
            pkg: pkg
        }
    };
};

module.exports = _bud;
