/**
 * apeman bud for seed projects.
 * @memberof module:apeman-bud-seed/lib
 * @function setup
 * @param {object} params - Template params.
 * @returns {object} - Coz bud configuration.
 */

"use strict";

const argx = require('argx'),
    assert = require('assert'),
    arrayreduce = require('arrayreduce'),
    extend = require('extend'),
    _bud = require('./_bud'),
    _tmpl = require('./_tmpl');

let concatArray = arrayreduce.arrayConcat();

/** @lends setup */
function setup(params) {
    let args = argx(arguments);
    params = args.shift('object') || {};

    let env = params.env,
        model = params.model;
    assert(env, 'params.env is required.');
    assert(model, 'params.model is required.');


    return [].concat(env).map((env) => {
        return [].concat(model).map((model) => {
            let tmpl = _tmpl(model);
            return _bud(tmpl, env, model, extend(params));
        }).reduce(concatArray, []).concat(
            _bud.seed(env, params)
        );
    }).reduce(concatArray, []);
}

module.exports = setup;
